/*
 * Gearsystem - Sega Master System / Game Gear Emulator
 * Copyright (C) 2013  Ignacio Sanchez

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/ 
 * 
 */

#ifndef OPCODECB_NAMES_H
#define	OPCODECB_NAMES_H

static stOPCodeInfo kOPCodeCBNames[256] = {
    { "RLC B", 2, 0 },
    { "RLC C", 2, 0 },
    { "RLC D", 2, 0 },
    { "RLC E", 2, 0 },
    { "RLC H", 2, 0 },
    { "RLC L", 2, 0 },
    { "RLC (HL)", 2, 0 },
    { "RLC A", 2, 0 },
    { "RRC B", 2, 0 },
    { "RRC C", 2, 0 },
    { "RRC D", 2, 0 },
    { "RRC E", 2, 0 },
    { "RRC H", 2, 0 },
    { "RRC L", 2, 0 },
    { "RRC (HL)", 2, 0 },
    { "RRC A", 2, 0 },

    { "RL B", 2, 0 },
    { "RL C", 2, 0 },
    { "RL D", 2, 0 },
    { "RL E", 2, 0 },
    { "RL H", 2, 0 },
    { "RL L ", 2, 0 },
    { "RL (HL)", 2, 0 },
    { "RL A", 2, 0 },
    { "RR B", 2, 0 },
    { "RR C", 2, 0 },
    { "RR D", 2, 0 },
    { "RR E", 2, 0 },
    { "RR H", 2, 0 },
    { "RR L", 2, 0 },
    { "RR (HL)", 2, 0 },
    { "RR A", 2, 0 },

    { "SLA B", 2, 0 },
    { "SLA C", 2, 0 },
    { "SLA D", 2, 0 },
    { "SLA E", 2, 0 },
    { "SLA H", 2, 0 },
    { "SLA L", 2, 0 },
    { "SLA (HL)", 2, 0 },
    { "SLA A", 2, 0 },
    { "SRA B", 2, 0 },
    { "SRA C", 2, 0 },
    { "SRA D", 2, 0 },
    { "SRA E", 2, 0 },
    { "SRA H", 2, 0 },
    { "SRA L", 2, 0 },
    { "SRA (HL)", 2, 0 },
    { "SRA A", 2, 0 },

    { "SLL B", 2, 0 },
    { "SLL C", 2, 0 },
    { "SLL D", 2, 0 },
    { "SLL E", 2, 0 },
    { "SLL H", 2, 0 },
    { "SLL L", 2, 0 },
    { "SLL (HL)", 2, 0 },
    { "SLL A", 2, 0 },
    { "SRL B", 2, 0 },
    { "SRL C", 2, 0 },
    { "SRL D", 2, 0 },
    { "SRL E", 2, 0 },
    { "SRL H", 2, 0 },
    { "SRL L", 2, 0 },
    { "SRL (HL)", 2, 0 },
    { "SRL A", 2, 0 },

    { "BIT 0 B", 2, 0 },
    { "BIT 0 C", 2, 0 },
    { "BIT 0 D", 2, 0 },
    { "BIT 0 E", 2, 0 },
    { "BIT 0 H", 2, 0 },
    { "BIT 0 L", 2, 0 },
    { "BIT 0 (HL)", 2, 0 },
    { "BIT 0 A", 2, 0 },
    { "BIT 1 B", 2, 0 },
    { "BIT 1 C", 2, 0 },
    { "BIT 1 D", 2, 0 },
    { "BIT 1 E", 2, 0 },
    { "BIT 1 H", 2, 0 },
    { "BIT 1 L", 2, 0 },
    { "BIT 1 (HL)", 2, 0 },
    { "BIT 1 A", 2, 0 },

    { "BIT 2 B", 2, 0 },
    { "BIT 2 C", 2, 0 },
    { "BIT 2 D", 2, 0 },
    { "BIT 2 E", 2, 0 },
    { "BIT 2 H", 2, 0 },
    { "BIT 2 L", 2, 0 },
    { "BIT 2 (HL)", 2, 0 },
    { "BIT 2 A", 2, 0 },
    { "BIT 3 B", 2, 0 },
    { "BIT 3 C", 2, 0 },
    { "BIT 3 D", 2, 0 },
    { "BIT 3 E", 2, 0 },
    { "BIT 3 H", 2, 0 },
    { "BIT 3 L", 2, 0 },
    { "BIT 3 (HL)", 2, 0 },
    { "BIT 3 A", 2, 0 },

    { "BIT 4 B", 2, 0 },
    { "BIT 4 C", 2, 0 },
    { "BIT 4 D", 2, 0 },
    { "BIT 4 E", 2, 0 },
    { "BIT 4 H", 2, 0 },
    { "BIT 4 L", 2, 0 },
    { "BIT 4 (HL)", 2, 0 },
    { "BIT 4 A", 2, 0 },
    { "BIT 5 B", 2, 0 },
    { "BIT 5 C", 2, 0 },
    { "BIT 5 D", 2, 0 },
    { "BIT 5 E", 2, 0 },
    { "BIT 5 H", 2, 0 },
    { "BIT 5 L", 2, 0 },
    { "BIT 5 (HL)", 2, 0 },
    { "BIT 5 A", 2, 0 },

    { "BIT 6 B", 2, 0 },
    { "BIT 6 C", 2, 0 },
    { "BIT 6 D", 2, 0 },
    { "BIT 6 E", 2, 0 },
    { "BIT 6 H", 2, 0 },
    { "BIT 6 L", 2, 0 },
    { "BIT 6 (HL)", 2, 0 },
    { "BIT 6 A", 2, 0 },
    { "BIT 7 B", 2, 0 },
    { "BIT 7 C", 2, 0 },
    { "BIT 7 D", 2, 0 },
    { "BIT 7 E", 2, 0 },
    { "BIT 7 H", 2, 0 },
    { "BIT 7 L", 2, 0 },
    { "BIT 7 (HL)", 2, 0 },
    { "BIT 7 A", 2, 0 },

    { "RES 0 B", 2, 0 },
    { "RES 0 C", 2, 0 },
    { "RES 0 D", 2, 0 },
    { "RES 0 E", 2, 0 },
    { "RES 0 H", 2, 0 },
    { "RES 0 L", 2, 0 },
    { "RES 0 (HL)", 2, 0 },
    { "RES 0 A", 2, 0 },
    { "RES 1 B", 2, 0 },
    { "RES 1 C", 2, 0 },
    { "RES 1 D", 2, 0 },
    { "RES 1 E", 2, 0 },
    { "RES 1 H", 2, 0 },
    { "RES 1 L", 2, 0 },
    { "RES 1 (HL)", 2, 0 },
    { "RES 1 A", 2, 0 },

    { "RES 2 B", 2, 0 },
    { "RES 2 C", 2, 0 },
    { "RES 2 D", 2, 0 },
    { "RES 2 E", 2, 0 },
    { "RES 2 H", 2, 0 },
    { "RES 2 L", 2, 0 },
    { "RES 2 (HL)", 2, 0 },
    { "RES 2 A", 2, 0 },
    { "RES 3 B", 2, 0 },
    { "RES 3 C", 2, 0 },
    { "RES 3 D", 2, 0 },
    { "RES 3 E", 2, 0 },
    { "RES 3 H", 2, 0 },
    { "RES 3 L", 2, 0 },
    { "RES 3 (HL)", 2, 0 },
    { "RES 3 A", 2, 0 },

    { "RES 4 B", 2, 0 },
    { "RES 4 C", 2, 0 },
    { "RES 4 D", 2, 0 },
    { "RES 4 E", 2, 0 },
    { "RES 4 H", 2, 0 },
    { "RES 4 L", 2, 0 },
    { "RES 4 (HL)", 2, 0 },
    { "RES 4 A", 2, 0 },
    { "RES 5 B", 2, 0 },
    { "RES 5 C", 2, 0 },
    { "RES 5 D", 2, 0 },
    { "RES 5 E", 2, 0 },
    { "RES 5 H", 2, 0 },
    { "RES 5 L", 2, 0 },
    { "RES 5 (HL)", 2, 0 },
    { "RES 5 A", 2, 0 },

    { "RES 6 B", 2, 0 },
    { "RES 6 C", 2, 0 },
    { "RES 6 D", 2, 0 },
    { "RES 6 E", 2, 0 },
    { "RES 6 H", 2, 0 },
    { "RES 6 L", 2, 0 },
    { "RES 6 (HL)", 2, 0 },
    { "RES 6 A", 2, 0 },
    { "RES 7 B", 2, 0 },
    { "RES 7 C", 2, 0 },
    { "RES 7 D", 2, 0 },
    { "RES 7 E", 2, 0 },
    { "RES 7 H", 2, 0 },
    { "RES 7 L", 2, 0 },
    { "RES 7 (HL)", 2, 0 },
    { "RES 7 A", 2, 0 },

    { "SET 0 B", 2, 0 },
    { "SET 0 C", 2, 0 },
    { "SET 0 D", 2, 0 },
    { "SET 0 E", 2, 0 },
    { "SET 0 H", 2, 0 },
    { "SET 0 L", 2, 0 },
    { "SET 0 (HL)", 2, 0 },
    { "SET 0 A", 2, 0 },
    { "SET 1 B", 2, 0 },
    { "SET 1 C", 2, 0 },
    { "SET 1 D", 2, 0 },
    { "SET 1 E", 2, 0 },
    { "SET 1 H", 2, 0 },
    { "SET 1 L", 2, 0 },
    { "SET 1 (HL)", 2, 0 },
    { "SET 1 A", 2, 0 },

    { "SET 2 B", 2, 0 },
    { "SET 2 C", 2, 0 },
    { "SET 2 D", 2, 0 },
    { "SET 2 E", 2, 0 },
    { "SET 2 H", 2, 0 },
    { "SET 2 L", 2, 0 },
    { "SET 2 (HL)", 2, 0 },
    { "SET 2 A", 2, 0 },
    { "SET 3 B", 2, 0 },
    { "SET 3 C", 2, 0 },
    { "SET 3 D", 2, 0 },
    { "SET 3 E", 2, 0 },
    { "SET 3 H", 2, 0 },
    { "SET 3 L", 2, 0 },
    { "SET 3 (HL)", 2, 0 },
    { "SET 3 A", 2, 0 },

    { "SET 4 B", 2, 0 },
    { "SET 4 C", 2, 0 },
    { "SET 4 D", 2, 0 },
    { "SET 4 E", 2, 0 },
    { "SET 4 H", 2, 0 },
    { "SET 4 L", 2, 0 },
    { "SET 4 (HL)", 2, 0 },
    { "SET 4 A", 2, 0 },
    { "SET 5 B", 2, 0 },
    { "SET 5 C", 2, 0 },
    { "SET 5 D", 2, 0 },
    { "SET 5 E", 2, 0 },
    { "SET 5 H", 2, 0 },
    { "SET 5 L", 2, 0 },
    { "SET 5 (HL)", 2, 0 },
    { "SET 5 A", 2, 0 },

    { "SET 6 B", 2, 0 },
    { "SET 6 C", 2, 0 },
    { "SET 6 D", 2, 0 },
    { "SET 6 E", 2, 0 },
    { "SET 6 H", 2, 0 },
    { "SET 6 L", 2, 0 },
    { "SET 6 (HL)", 2, 0 },
    { "SET 6 A", 2, 0 },
    { "SET 7 B", 2, 0 },
    { "SET 7 C", 2, 0 },
    { "SET 7 D", 2, 0 },
    { "SET 7 E", 2, 0 },
    { "SET 7 H", 2, 0 },
    { "SET 7 L", 2, 0 },
    { "SET 7 (HL)", 2, 0 },
    { "SET 7 A", 2, 0 }
};

#endif	/* OPCODECB_NAMES_H */

